<?php
function convert_data_get_categories($all = 0, $exclude = '', $data_type = 0, $prefix = '')
{
	$taxonomy = esc_attr(get_option('convert_data_taxonomy'));
	if( empty($taxonomy) ){
		$taxonomy = 'category';
	}

	$args = [
		'taxonomy' => $taxonomy,
		'orderby' => 'id',
		'order' => 'ASC',
		'hide_empty' => false,
		'exclude' => $exclude
	];

	$text = '';
	$text_array = '';

	$categories = get_terms( $args );
	if ( ! empty( $categories ) && ! is_wp_error( $categories ) ){

		$text = '<ul class="convert_data_ul">' . "\n";
		$text_array = '';
		$text_array .= '$c = [];' . "\n";
		foreach ($categories as $category) {
			$category_id = $category->term_id;
			$category_link = esc_url( get_term_link( $category ) );
			$category_count = $category->count;
			$category_category_count = $category->category_count;
			$category_slug = $category->slug;
			$category_term_taxonomy_id = $category->term_taxonomy_id;
			$category_category_parent = $category->category_parent;
			$category_parent = $category->parent;

			if (function_exists('convert_data_filter')) {
				$category_title = convert_data_filter($category->name);
				$category_description = convert_data_filter($category->description);
			} else {
				$category_title = esc_attr($category->name);
				$category_description = esc_attr($category->description);
			}

			if( $category_parent == 0 ) {
				$text .= '<li><a href="' . $category_link . '">' . $category_title . '</a>';

				$textSub = '';
				$text_sub_array = '';
				foreach( $categories as $sub_category ) {
					if($sub_category->parent == $category_id) {

						$sub_id = $sub_category->term_id;
						$sub_link = esc_url( get_term_link( $sub_category ) );
						if (function_exists('convert_data_filter')) {
							$sub_title = convert_data_filter($sub_category->name);
							$sub_description = convert_data_filter($sub_category->description);
						} else {
							$sub_title = esc_attr($sub_category->name);
							$sub_description = esc_attr($sub_category->description);
						}
		
						$sub_parent = $sub_category->parent;
		
						$textSub .= '<li><a href="' . $sub_link . '">' . $sub_title . '</a>';
		
						/* Start Sub Child */
						$textChild = '';
						$text_sub_child_array = '';
						foreach( $categories as $sub_child_category ) {
							if($sub_child_category->parent == $sub_id) {

								$sub_child_id = $sub_child_category->term_id;
								$sub_child_link = esc_url( get_term_link( $sub_child_category ) );
		
								if (function_exists('convert_data_filter')) {
									$sub_child_title = convert_data_filter($sub_child_category->name);
									$sub_child_description = convert_data_filter($sub_child_category->description);
								} else {
									$sub_child_title = esc_attr($sub_child_category->name);
									$sub_child_description = esc_attr($sub_child_category->description);
								}

								$sub_child_parent = $sub_child_category->parent;
		
								$textChild .= '<li><a href="' . $sub_child_link . '">' . $sub_child_title . '</a></li>' . "\n";
								$text_sub_child_array .= "[\n";
								$text_sub_child_array .= "'id' => '" . $sub_child_id . "',\n";
								$text_sub_child_array .= "'title' => '" . $sub_child_title . "',\n";
								$text_sub_child_array .= "'parent' => '" . $sub_child_parent . "',\n";
								$text_sub_child_array .= "'url' => '" . $sub_child_link . "',\n";
								$text_sub_child_array .= "],\n";
							}
						}
						if( !empty($textChild) ){
							$textSub .= "\n" . '<ul>' . "\n";
							$textSub .= $textChild;
							$textSub .= '</ul>' . "\n";
						}
						
						/* End Sub Child */
		
						$text_sub_array .= "[\n";
						$text_sub_array .= "'id' => '" . $sub_id . "',\n";
						$text_sub_array .= "'title' => '" . $sub_title . "',\n";
						$text_sub_array .= "'parent' => '" . $sub_parent . "',\n";
						$text_sub_array .= "'url' => '" . $sub_link . "',\n";
						if ($sub_description != "") {
							$text_sub_array .= "'description' => '" . $sub_description . "',\n";
						}
						if ($text_sub_child_array == "") {
							$text_sub_array .= '';
						} else {
							$text_sub_array .= "'child' => [\n" . $text_sub_child_array . "],\n";
						}
						$text_sub_array .= "],\n";
		
						$textSub .= '</li>' . "\n";
					}
				}

				if( !empty($textSub) && $all == 1 ){
					$text .= "\n" . '<ul>' . "\n";
					$text .= $textSub;
					$text .= '</ul>' . "\n";
				}

				$text .= '</li>' . "\n";

				$text_array .= '$c[\'' . $category_id . '\'] = [' . "\n";
				$text_array .= "'id' => '" . $category_id . "',\n";
				$text_array .= "'title' => '" . $category_title . "',\n";
				$text_array .= "'description' => '" . $category_description . "',\n";
				$text_array .= "'parent' => '" . $category_parent . "',\n";
				$text_array .= "'url' => '" . $category_link . "',\n";
				if ( !empty($text_sub_array) && $all == 1 ) {
					$text_array .= "'child' => [\n" . $text_sub_array . "],\n";
				}
				$text_array .= "];\n";
			}
		}
		$text .= '</ul>' . "\n";
	}

	if ($data_type == 1) {
		return "function " . $prefix . "categories(){\n" . $text_array . "\nreturn $" . "c;\n}";
	} else {
		return $text;
	}
}
